%define name Mesa
%define version 3.1
%define glx_ver	19991126

Name: %{name}
Version: %{version}
Release: 14mdk
Summary: OpenGL 1.2 compatible 3D graphics library
Group: System/Libraries
BuildRoot: %{_tmppath}/mesa-root
URL: http://www.mesa3d.org
Source: ftp://ftp.mesa3d.org/pub/mesa/MesaLib-%{version}.tar.bz2
Source1: ftp://ftp.mesa3d.org/pub/mesa/MesaDemos-%{version}.tar.bz2
Source2: glx-19991126.tar.bz2
Source3: Mesa-demos
Source4: %{name}-icons.tar.bz2
Patch0: %{name}-3.0-pthread.patch.bz2
Patch1: %{name}-%{version}-ppc.patch.bz2
Patch2: %{name}-remove-rpath.patch.bz2
Copyright: LGPL
Prefix: /usr/X11R6
Requires: Mesa-common

%package devel
Summary: development files for Mesa (OpenGL compatible 3D lib)
Group: Development/C
Requires: %{name} Mesa-common-devel

%package common
Summary: files for Mesa (GLU and glut libs)
Group: System/Libraries
Requires: %{name}

%package common-devel
Summary: development files for GLU and glut libs
Group: Development/C
Requires: %{name}-devel

%package demos
Summary: demos for Mesa (OpenGL compatible 3D lib)
Group: Graphics
Requires: %{name} >= %{version}

%description
Mesa is an OpenGL 1.2 compatible 3D graphics library.

%description common
Mesa is an OpenGL 1.2 compatible 3D graphics library.
glut and GLU parts.

%description devel
Mesa is an OpenGL 1.2 compatible 3D graphics library.

This package contains the headers needed to compile Mesa programs.

%description common-devel
Mesa is an OpenGL 1.2 compatible 3D graphics library.
glut and GLU parts.

This package contains the headers needed to compile Mesa programs.

%description demos
Mesa is an OpenGL 1.2 compatible 3D graphics library.

This package contains some demo programs for the Mesa library.

%prep
%setup -q -n Mesa-3.1

#Mesa-demos
tar xvfy %{SOURCE1} -C ../

# utah_glx
tar xvfy %{SOURCE2}


# %patch0 -p1 # Use patch0 if you want to build a threaded library
%ifarch ppc
%patch1 -p1 -b .ppc
%endif
%patch2 -p0

perl -p -i -e "s/-O3/$RPM_OPT_FLAGS/" Make-config
pushd demos && {
	for i in *.c; do 
	perl -pi -e "s|\.\./images/|%{prefix}/lib/mesa-demos-data/|" $i ; 
	done 
	perl -pi -e "s|isosurf.dat|%{prefix}/lib/mesa-demos-data/isosurf.dat|" isosurf.c 
} && popd

%build


%ifarch i386 i486 i586 k6 i686
./configure --prefix=%{prefix} --target=%{_target_cpu}-mandrake-linux-gnu
%else
./configure --prefix=%{prefix} \
	--target=%{_target_cpu}-mandrake-linux-gnu \
	--without-3dnow
%endif
%ifarch i386 i486 i586 k6 i686 
#make linux-386-pthread-shared
if [ x"$SMP" != x"" ]; then
	(make MAKE="make -j $SMP -k" ; exit 0)
	make 
else
	make 
fi
%else
# I dunno why this is here (ax)
if [ x"$SMP" != x"" ]; then
        (make MAKE="make -j $SMP -k" ; exit 0)
        make 
else
        make 
fi
%endif

pushd demos
for i in bounce clearspd drawpix gamma gears glinfo glutfx isosurf morph3d \
         multiarb osdemo paltex pointblast reflect renormal \
         spectex stex3d tessdemo texcyl texobj trispd winpos; do
	make $i 
done	
popd


%ifarch alpha sparc sparc64 ppc # Skip utah_glx for alpha - (fg) also skip it for
                                # sparc - (jb) also added skip for ppc
	echo 'utah_glx skipped for alpha, powerpc and sparcs'
%else
cd glx-%{glx_ver}
cp -fv ../config.sub ./
./autogen.sh --with-chipset=both --with-mesa=../ --enable-extra \
	--enable-mtrr --enable-agp \
	--prefix=%{prefix} \
	--sysconfdir=/etc \
	--target=%{_target_cpu}-mandrake-linux-gnu
# Arg docs sux
pushd docs
echo '
ac_cv_path_install=${ac_cv_path_install='/usr/bin/install -c'}
ac_cv_prog_CP=${ac_cv_prog_CP='cp -f'}
ac_cv_prog_LN_S=${ac_cv_prog_LN_S='ln -s'}
ac_cv_prog_MKDIR=${ac_cv_prog_MKDIR='mkdir -p'}
ac_cv_prog_MV=${ac_cv_prog_MV='mv -f'}
ac_cv_prog_RM=${ac_cv_prog_RM='rm -f'}
ac_cv_prog_have_dvips=${ac_cv_prog_have_dvips=no}
ac_cv_prog_have_jade=${ac_cv_prog_have_jade=no}
ac_cv_prog_have_jadetex=${ac_cv_prog_have_jadetex=no}
ac_cv_prog_have_lynx=${ac_cv_prog_have_lynx=yes}
ac_cv_prog_have_ps2pdf=${ac_cv_prog_have_ps2pdf=no}
ac_cv_prog_make_make_set=${ac_cv_prog_make_make_set=yes}

' > config.cache
./configure --disable-text --disable-html --disable-ps --disable-pdf
popd

if [ x"$SMP" != x"" ]; then
        (make MAKE="make -j $SMP -k"; exit 0)
        make 
else
        make 
fi
cd ..

## mach64
#cp -r glx-%{glx_ver} mach64_glx-%{glx_ver}
#cd mach64_glx-%{glx_ver}
#./autogen.sh --with-mesa=../ --with-chipset=mach64 --prefix=%{prefix} --sysconfdir=/etc --target=%{_target_cpu}
#if [ x"$SMP" != x"" ]; then
#        (make MAKE="make -j $SMP -k"; exit 0)
#        make
#else
#        make
#fi
%endif # Skip glx for Alpha


%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{prefix}/lib/mesa-demos-data
mkdir -p $RPM_BUILD_ROOT/usr/include
mkdir -p $RPM_BUILD_ROOT%{prefix}/etc/X11
#cp -arv lib/* $RPM_BUILD_ROOT%{prefix}/lib
#cp -arv include/GL $RPM_BUILD_ROOT/usr/include

make DESTDIR=$RPM_BUILD_ROOT	install

# Clean up and make it look like old Mesa
#mv $RPM_BUILD_ROOT%{prefix}/include/GL $RPM_BUILD_ROOT/usr/include

mkdir -p $RPM_BUILD_ROOT%{prefix}/bin
for i in bounce clearspd drawpix gamma gears glinfo glutfx isosurf morph3d \
         multiarb osdemo paltex pointblast reflect renormal \
         spectex stex3d tessdemo texcyl texobj trispd winpos; do
  cp -v demos/.libs/$i $RPM_BUILD_ROOT%{prefix}/bin
done

# (fg) So that demos at least work :)

cp -v images/*rgb demos/isosurf.dat $RPM_BUILD_ROOT%{prefix}/lib/mesa-demos-data 

# menu for demos
install -m 755 -d $RPM_BUILD_ROOT/usr/lib/menu
install -m 644 %{SOURCE3} $RPM_BUILD_ROOT/usr/lib/menu/

# icons for three demos examples [we lack a frontend to launch the demos obviously]
install -m 755 -d $RPM_BUILD_ROOT/usr/share/icons/mini
tar yxvf %{SOURCE4} -C $RPM_BUILD_ROOT/usr/share/icons/

%ifarch alpha sparc sparc64 ppc
echo 'Skipping utah_glx'
%else
echo '
#!/bin/sh
LD_PRELOAD=%{prefix}/lib/libGL.so.1.0 $@
' > $RPM_BUILD_ROOT%{prefix}/bin/glx
chmod +x $RPM_BUILD_ROOT%{prefix}/bin/glx

## mga
cd glx-%{glx_ver}
mkdir -p $RPM_BUILD_ROOT/etc/X11
make install prefix=$RPM_BUILD_ROOT%{prefix} sysconfdir=$RPM_BUILD_ROOT/etc
#mv $RPM_BUILD_ROOT%{prefix}/lib/modules/glx.so $RPM_BUILD_ROOT/usr/X11R6/lib/modules/mga_glx.so
cd ..

## mach64
#cd mach64_glx-%{glx_ver}
#make install DESTDIR=$RPM_BUILD_ROOT
#mv $RPM_BUILD_ROOT%{prefix}/lib/modules/glx.so $RPM_BUILD_ROOT/usr/X11R6/lib/modules/mach64_glx.so
#cd ..
%endif # glx 

cd $RPM_BUILD_ROOT/%{prefix}/lib/
ln -sf libGL.so.1 libGL.so
ln -sf libGLU.so.1 libGLU.so
ln -sf libglut.so.3 libglut.so

# (gc) add Mesa symlinks for compatibility
ln -sf libGL.so libMesaGL.so
ln -sf libGL.so.1 libMesaGL.so.1
ln -sf libGL.so.1.0 libMesaGL.so.1.0
ln -sf libGL.so.1.2.0 libMesaGL.so.1.2.0
ln -sf libGLU.so libMesaGLU.so
ln -sf libGLU.so.1 libMesaGLU.so.1
ln -sf libGLU.so.1.2.0 libMesaGLU.so.1.2.0
ln -sf libGLU.so.3 libMesaGLU.so.3
ln -sf libGLU.so.3.1.2 libMesaGLU.so.3.1.2


%post
ldconfig 

%postun
ldconfig

%post common
ldconfig 

%postun common
ldconfig

%post demos
## menu
if [ -x /usr/bin/update-menus ]; then
  /usr/bin/update-menus
fi

%postun demos
## menu
if [ "$1" = 0 ]; then
  if [ -x /usr/bin/update-menus ]; then
      /usr/bin/update-menus
  fi
fi  

%files
%defattr(-,root,root)
%doc docs/COPYRIGHT docs/README docs/README.X11 docs/COPYING
%{prefix}/lib/libGL.so.*
%{prefix}/lib/libMesaGL.so.*
%ifarch i386 i486 i586 i686 k6
%{prefix}/lib/modules/*
%config /etc/X11/glx.conf
%endif
%{prefix}/etc/mesa.conf

%files devel
%defattr(-,root,root)
%doc docs/COPYRIGHT docs/README docs/README.X11 docs/COPYING docs/DEVINFO docs/CONFORM docs/VERSIONS
%dir %{prefix}/include/GL
%{prefix}/include/GL/gl.h
%{prefix}/include/GL/gl_mangle.h
%{prefix}/include/GL/osmesa.h
%ifarch i386 i486 i586 i686 k6
%{prefix}/include/GL/svgamesa.h
%endif
%{prefix}/include/GL/glx.h
%{prefix}/include/GL/glx_mangle.h
%{prefix}/include/GL/xmesa.h
%{prefix}/include/GL/xmesa_x.h
%{prefix}/include/GL/xmesa_xf86.h
%{prefix}/lib/libGL.so
%{prefix}/lib/libMesaGL.so

%files common
%defattr(-,root,root)
%doc docs/COPYRIGHT docs/README docs/README.X11 docs/COPYING
%{prefix}/lib/libGLU.so.*
%{prefix}/lib/libMesaGLU.so.*
%{prefix}/lib/libglut.so.*

%files common-devel
%defattr(-,root,root)
%doc docs/COPYRIGHT docs/README docs/README.X11 docs/COPYING
%{prefix}/include/GL/glu.h
%{prefix}/include/GL/glu_mangle.h
%{prefix}/include/GL/glut.h
%{prefix}/lib/libGLU.so
%{prefix}/lib/libMesaGLU.so
%{prefix}/lib/libglut.so
%{prefix}/lib/libGL.la
%{prefix}/lib/libGLU.la
%{prefix}/lib/libglut.la

%files demos
%defattr(-,root,root)
%doc docs/COPYRIGHT docs/README docs/README.X11 docs/COPYING
%{prefix}/bin/*
%dir %{prefix}/lib/mesa-demos-data
%{prefix}/lib/mesa-demos-data/*
/usr/lib/menu/Mesa-demos
/usr/share/icons/*demos*.xpm
/usr/share/icons/mini/*demos*.xpm

%changelog
* Sun May  7 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-14mdk
- added more compatibility links to Mesa for Fermigier

* Fri Apr 28 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-13mdk
- really fixed hardcoded path

* Fri Apr 28 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-12mdk
- added 32x32 icons, fixed hardcoded path in menu entries

* Mon Apr 17 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-11mdk
- added symlinks to libMesaGL and libMesaGLU for compatibility
  with older applications

* Wed Apr 12 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 3.1-10mdk
- fixed group for Mesa-demos
- added menu entries for best demos
- fixed ftp, added url
- added documentation
- patched ltconfig to remove binary-or-shlib-defines-rpath

* Mon Apr  3 2000 Frederic Lepied <flepied@mandrakesoft.com> 3.1-9mdk
- split glut and GLU in common and common-devel packages to ease
the upgrade to XFree86 4.0.

* Sun Mar 19 2000 John Buswell <johnb@mandrakesoft.com> 3.1-8mdk
- Added patch for PPC arch
- Included PPC in GLX skip
- Added ifarch 

* Fri Jan 28 2000 Francis Galiegue <francis@mandrakesoft.com>

- Added .so symlinks in -devel


* Mon Jan 17 2000 Francis Galiegue <francis@mandrakesoft.com>

- Made demos fully functional


* Mon Jan 17 2000 Francis Galiegue <francis@mandrakesoft.com>

- Also skip svgalib for sparcs

* Thu Jan 13 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 3.1-4mdk
- Make sure to get the right link.

* Tue Jan 11 2000 Pixel <pixel@mandrakesoft.com>
- fix build for non-svgalib architectures

* Mon Dec 20 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- id k6 chipset as i586 for glx

* Tue Dec 14 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Mesa 3.1 final.
- rewrite files

* Sat Dec 11 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
-  Really fix alpha build (no glx for you)
- and use _tmppath in Buildroot

* Tue Dec 07 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Fix alpha build (i think)
- Clean up .spec (scared chmou, big wuss) ;)
- make cheesie 'glx' script to LD_PRELOAD the libGL.so.1.0 for the demos

* Fri Nov 26 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- Update cvs snaps
- Use new --with-chipset=both for glx
- (this is not backwards compatible, you must recompile) don't blame me ask the Mesa people
- use the right --target (must say they did a damned fine job of optimizing the code

* Tue Nov 02 1999 Axalon Bloodstone <axalon@linux-mandrake.com>
- add arch's, defattr
- integrate glx (mga_gxl.so, tnt_glx.so)

* Mon Oct 11 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>

- Back to old Mesa lib.

* Fri Jul 16 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.de>
- remove the -ffast-math removal stuff - Mesa 3.1 works with -ffast-math
  and is actually 11.7% faster than without it.

* Fri Jul 16 1999 Bernhard Rosenkraenzer <bero@mandrakesoft.de>
- 3.1beta2

* Wed Jun 30 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Build in the new environement (rel: 3mdk).

* Thu May 06 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- ldconfig to %post and %postun.

* Mon Feb 15 1999 Bernhard Rosenkraenzer <bero@microsoft.sucks.eu.org>
- initial RPM; changes to base:
  - Handle RPM_OPT_FLAGS
  - link with pthread library
